package com.sun.java.swing;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;

import java.util.*;
import com.sun.java.accessibility.*;
import com.sun.java.swing.plaf.PopupMenuUI;
import com.sun.java.swing.plaf.ComponentUI;
import com.sun.java.swing.event.*;

import java.applet.Applet;

public class pPopup extends JPopupMenu implements Accessible,MenuElement {
    int mode=2;
    public static final int SINGLE=0;
    public static final int DOUBLE=2;
    public static final int QUAD  =4;
    
    
    public pPopup(){
        super();
        setPopmode(DOUBLE);
        addMouseListener(new badMouse());
        addKeyListener(new badKey());
    }
    
    public pPopup(Vector sw, Vector se, Vector nw, Vector ne){
        this();
        setPopmode(QUAD);
        addsw(sw);
        addse(se);
        addne(ne);
        addnw(nw);
    }
    public pPopup(Vector wrap){
        this();
        split(wrap);
    }
    
    public void split(Vector wrap){
        Enumeration en = wrap.elements();
        try{
            while(true){
                JMenuItem mi = (JMenuItem)en.nextElement();
                add(mi);
            }
        }catch(NoSuchElementException e){}
        
    }
    
    //Shortcuts
    int swm = 0, sem = 0, nwm = 0, nem = 0, nwem = 0;
    int sw = 101, se = 101, nw = 100, ne = 100;
    
    public void addsw(Vector swv){
        if(swv == null) return;
        Enumeration en = swv.elements();
        try{
            while(true){
                JMenuItem menuItem = (JMenuItem)en.nextElement();
                GridBagConstraints gbc = new GridBagConstraints();
                gbc.fill = GridBagConstraints.HORIZONTAL;
                gbc.gridx = 10;
                gbc.gridy = sw++;
                add(menuItem, gbc);
                swm = Math.max(menuItem.getPreferredSize().width, swm);
            }
        }catch(NoSuchElementException e){}
    }
    
    public void addse(Vector swv){
        if(swv == null) return;
        Enumeration en = swv.elements();
        try{
            while(true){
                JMenuItem menuItem = (JMenuItem)en.nextElement();
                GridBagConstraints gbc = new GridBagConstraints();
                gbc.fill = GridBagConstraints.HORIZONTAL;
                gbc.gridx = 0;
                gbc.gridy = se++;
                add(menuItem, gbc);
                sem = Math.max(menuItem.getPreferredSize().width, sem);
            }
        }catch(NoSuchElementException e){}
    }
    
    public void addne(Vector nwv){
        if(nwv == null) return;
        setPopmode(QUAD);
        Enumeration en = nwv.elements();
        try{
            while(true){
                JMenuItem menuItem = (JMenuItem)en.nextElement();
                GridBagConstraints gbc = new GridBagConstraints();
                gbc.fill = GridBagConstraints.HORIZONTAL;
                gbc.gridx = 10;
                gbc.gridy = nw--;
                add(menuItem, gbc);
                nwem = Math.max(menuItem.getPreferredSize().width, nwem);
                nwm += menuItem.getPreferredSize().height;
            }
        }catch(NoSuchElementException e){}
    }
    
    public void addnw(Vector nwv){
        if(nwv == null) return;
        setPopmode(QUAD);
        Enumeration en = nwv.elements();
        try{
            while(true){
                JMenuItem menuItem = (JMenuItem)en.nextElement();
                GridBagConstraints gbc = new GridBagConstraints();
                gbc.fill = GridBagConstraints.HORIZONTAL;
                gbc.gridx = 0;
                gbc.gridy = ne--;
                add(menuItem, gbc);
                nem += menuItem.getPreferredSize().height;
            }
        }catch(NoSuchElementException e){}
    }
    
    public void setPopmode(int chmod){
        //check range
        mode = chmod;
    }
    
    /**
     * Appends the specified menu item to the end of this menu. 
     *
     * @param c the JMenuItem to add
     * @return the JMenuItem added.
     */
     boolean xcnt=false;
    public JMenuItem add(JMenuItem menuItem) {
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.HORIZONTAL;
        if(xcnt = !xcnt || mode != SINGLE){
         gbc.gridx = 0;
        gbc.gridy = getComponentCount();
        }else{
            gbc.gridx = 10;
        gbc.gridy = getComponentCount()-1;
        }
        add(menuItem, gbc);
        return menuItem;
    }

    /**
     * Appends the specified component to the end of this menu. 
     *
     * @param c the Component to add
     * @return the Component added.
     */
    public Component add(Component c) {
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.HORIZONTAL;
        if(xcnt = !xcnt || mode != SINGLE){
         gbc.gridx = 0;
        gbc.gridy = getComponentCount();
        }else{
            gbc.gridx = 10;
        gbc.gridy = getComponentCount()-1;
        }
        add(c, gbc);
        return c;
    }


    protected static Frame getFrame(Component c) {
        Component w = c;

        while(!(w instanceof Frame) && (w!=null)) {
            w = w.getParent();
        }
        return (Frame)w;
    }

    public void show(Component invoker, int x, int y) {
        setInvoker(invoker);
        Frame newFrame = getFrame(invoker);
        if (newFrame != frame) {
            // Use the invoker's frame so that events 
            // are propogated properly
            if (newFrame!=null) {
                this.frame = newFrame;
                if(popup != null) {
                    setVisible(false);
                }
            }
        }
        Point invokerOrigin = invoker.getLocationOnScreen();
        //Move the show point so that the cursor is at 0,0 on the compass.
        if(mode != SINGLE){
            invokerOrigin.x -= Math.max(sem, nwem) + 10;
            //20 == fudge Border, insets??
        }
        if(mode == QUAD){
            invokerOrigin.y -= Math.max(nwm, nem)+ 5;
        }
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        if(invokerOrigin.x + x < 10){
            invokerOrigin.x = 10;
        }
        if(invokerOrigin.y + y < 10){
            invokerOrigin.y = 10;
        }
        if(invokerOrigin.x + x +  getWidth() > screenSize.width){
            invokerOrigin.x = screenSize.width - getWidth() - x;
        }
        if(invokerOrigin.y + y +  getHeight() > screenSize.height){
            invokerOrigin.y = screenSize.height - getHeight() - y;
        }
        setLocation(invokerOrigin.x + x, 
                    invokerOrigin.y + y);
        setVisible(true);       
/*        if((invokerOrigin.x + x +  getWidth() > screenSize.width)
        &&(invokerOrigin.y + y + getHeight() > screenSize.height)){
            setLocation(screenSize.width-getWidth(), screenSize.height-getHeight());
        }
        if(invokerOrigin.x + x +  getWidth() > screenSize.width){
            setLocation(screenSize.width-getWidth(), invokerOrigin.y + y);
        }
        if(invokerOrigin.y + y + getHeight() > screenSize.height){
            setLocation(invokerOrigin.x + x, screenSize.height-getHeight());
        }
     */       
    }
    
    /**convience functions:
    addActionListener & removeActionListener add the listener to each MenuItem
    */
    public void addActionListener(ActionListener l) {
        Component[] c = getComponents();
        for(int x = 0; x < c.length; x++){
            try{
                ((JMenuItem)c[x]).addActionListener(l);
            }catch(Exception e){
                //possibly not a JMI
            }
        }
    }
    public void removeActionListener(ActionListener l) {
        Component[] c = getComponents();
        for(int x = 0; x < c.length; x++){
            try{
                ((JMenuItem)c[x]).removeActionListener(l);
            }catch(Exception e){
                //possibly not a JMI
            }
        }
        
    }
    
    /**
     * Inserts a menu item for the specified Action object at a given
     * position.
     *
     * @param component  the Action object to insert
     * @param index      an int specifying the position at which
     *                   to insert the Action, where 0 is the first
     * @see Action
     */
    public void insert(Action a, int index) {
        JMenuItem mi = new JMenuItem((String)a.getValue(Action.NAME),
                                     (Icon)a.getValue(Action.SMALL_ICON));
        mi.setHorizontalTextPosition(JButton.RIGHT);
        mi.setVerticalTextPosition(JButton.CENTER);
        mi.setEnabled(a.isEnabled());
        mi.addActionListener(a);
        insert(mi, index);
    }

	class badMouse extends java.awt.event.MouseAdapter
	{
		public void mouseReleased(java.awt.event.MouseEvent event)
		{
			mouse_bad(event);
		}

		public void mouseExited(java.awt.event.MouseEvent event)
		{
		    Dimension xy = getSize();
//System.err.print(xy.width);
//System.err.print("  X ");
//System.err.print(event.getX());
//System.err.print("  w ");
//System.err.print(xy.height);
//System.err.print("  y ");
//System.err.print(event.getY());
//System.err.print("  ? ");
		    if(xy.width <= event.getX() || event.getX() <=0 ||
		        xy.height <= event.getY() || event.getY() <=0){
//System.err.print("Closed");
			    mouse_bad(event);
			}
//System.err.println();
		}
	}
	public void mouse_bad(java.awt.event.MouseEvent event){
	    //The mouse has indicated a close event
	    //System.err.println("MOUSE CLOSE");
	    setVisible(false);
	}
	
	public void key_bad(java.awt.event.KeyEvent event){
	    //The keyboard has indicated a close event
	    if(event.getKeyCode() == event.VK_ESCAPE){
	        System.err.println("MOUSE CLOSE");
	        setVisible(false);
	    }
	}
	
	class badKey extends java.awt.event.KeyAdapter
	{
		public void keyPressed(java.awt.event.KeyEvent event)
		{
		    System.err.println("A key is not working");
			key_bad(event);
		}
	}

	
}
